﻿//bookmark.html页面相关js
//创建：汪浩（qq :346819890） 2016-11-12

var plus = parent.plus;

var cookieName = "yhapp_bm";
var arrBookmark = [];

$(document).ready(function () {
    $("#btnSave").bind("click", saveBookmark);

    var lastcookie = parent.getCookie(cookieName); //读取cookie值  
    if (lastcookie == null) {
        //加载默认
        $.getJSON("../config/bookmark.json", function (data) {
            arrBookmark = data.extents;
            lastcookie = JSON.stringify(arrBookmark);
            parent.addCookie(cookieName, lastcookie);

            arrBookmark = eval(lastcookie);
            initBookMarkList();
        });
    }
    else
        initBookMarkList();
});


function initBookMarkList() {
    $("#bookmarkul").html("");

    var lastcookie = parent.getCookie(cookieName); //读取cookie值  
    if (lastcookie == null)
        return;

    arrBookmark = eval(lastcookie);
    if (arrBookmark == null || arrBookmark.length == 0) return;


    var inhtml = "";
    for (var index = arrBookmark.length - 1; index >= 0 ; index--) {
        var item = arrBookmark[index];

        inhtml += '<li class="mui-table-view-cell" >  <a href="javascript:showBookMark(' + item.data + ');" >'
            + item.name + '</a>  <button type="button" class="mui-btn mui-btn-danger mui-btn-outlined" onclick="delBookMark(\''
        + item.name + '\')">   <span class="mui-icon mui-icon-trash"></span>删除  </button></li>';

    }
    $("#bookmarkul").html(inhtml);
}




//添加
function saveBookmark() {
    if (arrBookmark == null)
        arrBookmark = [];

    var name = $.trim($("#txtName").val()).replace("'", "").replace('"', "");
    if (name.length == 0) {  
        mui.toast('请输入名称');
        return;
    }
    for (var index = arrBookmark.length - 1; index >= 0 ; index--) {
        if (arrBookmark[index].name == name) {
            mui.toast('该名称已存在，请更换！'); 
            return;
        }
    }

    var bounds = parent.map.getBounds().toBBoxString();
    var item = { name: name, data: bounds };
    arrBookmark.push(item);
    lastcookie = JSON.stringify(arrBookmark);
    parent.addCookie(cookieName, lastcookie);

    $("#txtName").val("");
    initBookMarkList();
}


function showBookMark(xmin, ymin, xamx, ymax) { 
    parent.fitExtent(xmin, ymin, xamx, ymax);
    toIndex();
}


function delBookMark(name) {
    for (var index = arrBookmark.length - 1; index >= 0 ; index--) {
        if (arrBookmark[index].name == name) {
            arrBookmark.splice(index, 1);

            var lastcookie = JSON.stringify(arrBookmark);
            parent.addCookie(cookieName, lastcookie);

            initBookMarkList();
            return;
        }
    }
}


//返回首页
function toIndex() {
    parent.hideExPage();
}