﻿//route.html页面相关js
//创建：汪浩（qq :346819890） 2016-11-10
 

//高德服务相关参数，从config读取
var gaode_server;

//poi服务
//var poi_server_url;

var selectedType;
$(document).ready(function () {
   
    gaode_server = parent.gisdata.config.gaode;
    //poi_server_url = parent.gisdata.config.yhserver.poi;

    $(".-nav-content a").click(function () {
        selectedType = this.id;
        var $this = $(this);
        $this.removeClass("gray").addClass("blue");
        $(".-nav-content ." + $this.attr("toLink")).removeClass("blue").addClass("gray");
    })

    $("#swap-position").on("click", function () {
        var str_start_mc = $.trim($("#txt-start").val());
        var str_start_jwd = $("#txt-start-jwd").val();
        var str_end_mc = $.trim($("#txt-end").val());
        var str_end_jwd = $("#txt-end-jwd").val();


        $("#txt-start").val(str_end_mc);
        $("#txt-start-jwd").val(str_end_jwd);

        $("#txt-end").val(str_start_mc);
        $("#txt-end-jwd").val(str_start_jwd);

    });


    $("#txt-start").on("input propertychange", poiTxtChangeHndler); 
    $("#txt-start").focus(poiTxtFocusHndler); 
    $("#txt-start").blur(poiTxtBlueHndler); 
    $("#txt-end").on("input propertychange", poiTxtChangeHndler);
    $("#txt-end").focus(poiTxtFocusHndler);
    $("#txt-end").blur(poiTxtBlueHndler);


    $("#clear-route-start").on("click", function () {
        $("#txt-start").val('');
        $("#resultlist").hide();
    });
    $("#clear-route-end").on("click", function () {
        $("#txt-end").val('');
        $("#resultlist").hide();
        
    });

    $(".-nav-search").bind("click", analysisRouteStartEed);

    if (parent.workLXGH.hasData())
        $("#footer_clear").show();
    else
        $("#footer_clear").hide();

    $("#footer_clear").click(function (evt) {
        $("#footer_clear").hide();
        parent.workLXGH.clear();

        $("#resultlist").hide();
        $("#smartTip").hide();
        $("#route-history-list").show();

        parent.hideExPage();
    });



    showRouteHistoryList();

    var param = getRequest(); 
    if (param.jwd) {
        $("#txt-start").val('我的位置');
        if (parent.gisdata.location == null) {
            showMsg("无法获取您当前所在位置！"); 
        }
        var str_start_jwd = parent.gisdata.location.lng + "," + parent.gisdata.location.lat;
        $("#txt-start-jwd").val(str_start_jwd); 
         
        $("#txt-end").val(param.name);
        $("#txt-end-jwd").val(param.jwd);

        queryRoute(true);
    } 

});

//历史记录
var historyListCount = 0;
var cookieName = 'yhapp_route';

var arrHistory = [];
function showRouteHistoryList() { 
    $("#route-history-list").hide();

    var lastcookie = parent.getCookie(cookieName); //读取cookie值  
    if (lastcookie ==null) return;
     
    arrHistory = eval(lastcookie);
    if (arrHistory == null || arrHistory.length == 0) return;
     
    var inhtml = "";
    for (var index = arrHistory.length-1; index>=0 ; index--) {
        var item = arrHistory[index];
          
        var type = (item.type == "nav-type-bus"?"公交":"驾车")
        inhtml += "<li><a href=\"javascript:showHistory(" + index + ");\"> <i class=\"menuItem07 fa fa-history fa-2x\"></i>【" + type + "】<span>" + item.start + " > </span><span>" + item.end + "</span> </a></li>";
    } 
    $("#historyul").html(inhtml); 

    $("#route-history-list").show(); 
}

function clearHistory() {
    arrHistory = [];
    parent.deleteCookie(cookieName);
    $("#historyul").html("");
    $("#route-history-list").hide();
}

//记录历史值 
function addRouteHistory(data) { 
    arrHistory = [];
    var lastcookie = parent.getCookie(cookieName); //读取cookie值  
    if (lastcookie != null) {
        arrHistory = eval(lastcookie);
    }
    arrHistory.push(data);

    if (arrHistory.length > 9)
        arrHistory.splice(0, 1);

    lastcookie = JSON.stringify(arrHistory);
    parent.addCookie(cookieName, lastcookie);
}

function showHistory(index) {
    var item = arrHistory[index];

    selectedType = item.type;
    if (selectedType == "nav-type-bus") 
        $("#nav-type-bus").click(); 
    else  
        $("#nav-type-car").click();


    $("#txt-start").val(item.start);
    $("#txt-start-jwd").val(item.start_jwd);

    $("#txt-end").val(item.end);
    $("#txt-end-jwd").val(item.end_jwd);

    queryRoute(true); 
}

 
function poiTxtBlueHndler() { 
    var temp = $("#smartTip").is(":hidden");
 
    if ( temp &&historyListCount > 0)
        $("#route-history-list").show();
}

function poiTxtFocusHndler() {
    if (isAutoSel) {
        isAutoSel = false;
        return;
    }

    //文本框内容为空
    var txtval = $.trim($(this).val());
    var inputid = this.id;

    $("#route-history-list").hide();

    $("#smartTip").show();
    if (txtval == '' || txtval == '我的位置' || txtval.indexOf('图上选点')!=-1) {
        var inhtml = getDefPoiHtml(inputid);
        $("#tippoi").html(inhtml); 
    } 
    else if (last_showpoi_text != txtval || inputid!=last_showpoi_inputid) {
        showpoitxt(txtval, inputid);
    } 
}

function getDefPoiHtml(inputid) {
    var inhtml = "<li style='background: url(../resources/img/route/time.png) 10px 12px no-repeat;'><a href=\"javascript:setSelPoi('" + inputid + "','我的位置','');\">我的位置</a></li>"
                 + "<li style='background: url(../resources/img/route/time.png) 10px 12px no-repeat;'><a href=\"javascript:selectMpt('" + inputid + "');\">图上选点</a></li>";

    return inhtml;
}

//起点及终点选择
function poiTxtChangeHndler() { 
    if (isAutoSel) {
        isAutoSel = false;
        return;
    }

    //文本框内容为空
    var txtval = $.trim($(this).val());
    var inputid = this.id;
    showpoitxt(txtval, inputid);
}

//起点及终点选择
var last_showpoi_inputid;
var last_showpoi_text;
function showpoitxt(txtval, inputid) {
    last_showpoi_text = txtval;
    last_showpoi_inputid = inputid;

    $("#resultlist").hide();
    $("#route-history-list").hide();
    $("#smartTip").show();

    if (inputid == 'txt-start') {
        $("#txt-start-jwd").val('');
    }
    else {
        $("#txt-end-jwd").val('');
    }
     
    if (txtval.length > 1) {
        //文本框内容不为空 
        $("#tippoi").html("");

        //poi服务
        //$.get(poi_server_url + "?poi=" + txtval, function (json) {
        //    var arrdata = eval(json);
        //    if (arrdata == null || arrdata.length == 0) return

        //    var length = arrdata.length;
        //    if (length > 10) length = 10;

        //    var inhtml = getDefPoiHtml(inputid);
        //    for (var index = 0; index < length; index++) {
        //        var item = arrdata[index];
        //        var point = item.point; //POINT(120.036029881 30.24560232)
        //        var index1 = point.indexOf('(');
        //        var index2 = point.indexOf(' ');
        //        var strjd = point.substring(index1 + 1, index2);
        //        var strwd = point.substring(index2 + 1, point.length - 1);
        //        var mc = item.shortName;

        //        inhtml += "<li><a href=\"javascript:setSelPoi('" + inputid + "','" + mc + "','" + strjd + "," + strwd + "');\">" + mc + "</a></li>"; 
        //    } 
        //    $("#tippoi").html(inhtml);  
        //});

        //poi arcgcis服务
        parent.workLXGH.queryPOI(txtval);



    }
    else {
        var inhtml = getDefPoiHtml(inputid);
        $("#tippoi").html(inhtml); 
    }
}


function poiQueryResult(arrdata) {
   
    if (arrdata == null || arrdata.length == 0) return

    var length = arrdata.length;
    if (length > 10) length = 10;

    var inhtml = getDefPoiHtml(last_showpoi_inputid);
    for (var index = 0; index < length; index++) {
        var item = arrdata[index]; 
        var mc = item.name; 
        var strjd = item.jd;
        var strwd = item.wd;
        inhtml += "<li><a href=\"javascript:setSelPoi('" + last_showpoi_inputid + "','" + mc + "','" + strjd + "," + strwd + "');\">" + mc + "</a></li>";
    } 
    $("#tippoi").html(inhtml);   
}


var isAutoSel = false;
function setSelPoi(type, mc, jwd) {
    isAutoSel = true;
    if (type == 'txt-start') {
        $("#txt-start").val(mc);
        $("#txt-start-jwd").val(jwd);
    }
    else {
        $("#txt-end").val(mc);
        $("#txt-end-jwd").val(jwd);
    }
    $("#smartTip").hide();
}

//图上选点
var lastSelMptType;
function selectMpt(type) {
    lastSelMptType = type;
    parent.workTSXD.startTsxd();
}
function endSelectMpt(latlng) {
    var jd = latlng.lng.toFixed(6);
    var wd = latlng.lat.toFixed(6);

    var jwd = jd + "," + wd;
    var mc = "图上选点(" +jwd + ")";

    if (lastSelMptType == 'txt-start') {
        $("#txt-start").val(mc);
        $("#txt-start-jwd").val(jwd);
    }
    else {
        $("#txt-end").val(mc);
        $("#txt-end-jwd").val(jwd);
    }
    $("#smartTip").hide();
}


function toIndex() {
    parent.hideExPage();
}


//分析起点及终点的经纬度
function analysisRouteStartEed() {
    var str_start_mc = $.trim($("#txt-start").val());
    var str_start_jwd = $("#txt-start-jwd").val();
    var str_end_mc = $.trim($("#txt-end").val());
    var str_end_jwd = $("#txt-end-jwd").val();

    //当坐标是我的位置时处理
    if (str_start_mc == '我的位置') {
        if (parent.gisdata.location == null) {
            showMsg("无法获取您当前所在位置！");
            return;
        }
        str_start_jwd = parent.gisdata.location.lng + "," + parent.gisdata.location.lat;
        $("#txt-start-jwd").val(str_start_jwd);
    }
    //当坐标是我的位置时处理
    if (str_end_mc == '我的位置') {
        if (parent.gisdata.location == null) {
            showMsg("无法获取您当前所在位置！");
            return;
        }
        str_end_jwd = parent.gisdata.location.lng + "," + parent.gisdata.location.lat;
        $("#txt-end-jwd").val(str_end_jwd);
    }

    // 
    if (str_start_mc == '') {
        showMsg("请选择起点");
        return;
    }
    if (str_end_mc == '') {
        showMsg("请选择终点");
        return;
    }
    
    if (str_start_jwd == '') {
        //进行地理编码
        var key = getRandomArrayOne(gaode_server.key);
        $.get(gaode_server.geocode_url + "&key=" + key + "&address=" + str_start_mc, function (json) {
            var data = eval(json);
            if (data.status == 0) {
                showMsg("起点地理编码请求失败(" + data.infocode + ")：" + data.info);
                return;
            }

            var geocodes = data.geocodes;
            if (geocodes == null || geocodes.length == 0) {
                showMsg("无法找到" + str_start_mc + "所在的位置!");
                return;
            }

            str_start_mc = geocodes[0].formatted_address;
            str_start_jwd = geocodes[0].location;
            //纠偏 
            var temp = str_start_jwd.split(',');
            var jd = Number(temp[0]);
            var wd = Number(temp[1]);
            var result = pointconvert.gcj2wgs([jd, wd]);
            str_start_jwd = result[0] + "," + result[1];


            $("#txt-start").val(str_start_mc);
            $("#txt-start-jwd").val(str_start_jwd);
            queryRoute();
        }); 
    }

    if (str_end_jwd == '') {
        //进行地理编码
        var key = getRandomArrayOne(gaode_server.key);
        $.get(gaode_server.geocode_url + "&key=" + key + "&address=" + str_end_mc, function (json) {
            var data = eval(json);
            if (data.status == 0) {
                showMsg("终点地理编码请求失败(" + data.infocode + ")：" + data.info);
                return;
            }
            var geocodes = data.geocodes;
            if (geocodes == null || geocodes.length == 0) {
                showMsg("无法找到" + str_end_mc + "所在的位置!");
                return;
            }
            
            str_end_mc = geocodes[0].formatted_address;
            str_end_jwd = geocodes[0].location;
            //纠偏 
            var temp = str_end_jwd.split(',');
            var jd = Number(temp[0]);
            var wd = Number(temp[1]);
            var result = pointconvert.gcj2wgs([jd, wd]);
            str_end_jwd = result[0] + "," + result[1];


            $("#txt-end").val(str_end_mc);
            $("#txt-end-jwd").val(str_end_jwd);
            queryRoute();

        }); 
    }

    queryRoute();
}


function queryRoute(isHistory) { 
    var str_start_mc = $.trim($("#txt-start").val());
    var str_start_jwd = $("#txt-start-jwd").val();
    var str_end_mc = $.trim($("#txt-end").val());
    var str_end_jwd = $("#txt-end-jwd").val();

    
    if (str_start_jwd == '' || str_end_jwd == '') {
        return;
    }

    //记录历史值 
    if (!isHistory) {
        addRouteHistory({
            type: selectedType,
            start: str_start_mc,
            start_jwd: str_start_jwd,
            end: str_end_mc,
            end_jwd: str_end_jwd,
        }); 
    }
    var temp = str_start_jwd.split(',');
    var jd = Number(temp[0]);
    var wd = Number(temp[1]);
    var startMpt = { mc: str_start_mc, jd: jd, wd: wd };
    //加偏 
    var result = pointconvert.wgs2gcj([jd, wd]);
    str_start_jwd = result[0] + "," + result[1];

    var temp = str_end_jwd.split(',');
    var jd = Number(temp[0]);
    var wd = Number(temp[1]);
    var endMpt = { mc: str_start_mc+" -> "+str_end_mc, jd: jd, wd: wd };
    //加偏 
    var result = pointconvert.wgs2gcj([jd, wd]);
    str_end_jwd = result[0] + "," + result[1];
     
    //调用服务 
    var key = getRandomArrayOne(gaode_server.key);
    var urltemp;
    if (selectedType == "nav-type-bus")
        urltemp = gaode_server.route_bus_url + "&key=" + key + "&origin=" + str_start_jwd + "&destination=" + str_end_jwd;
    else
        urltemp = gaode_server.route_car_url + "&key=" + key + "&origin=" + str_start_jwd + "&destination=" + str_end_jwd;

    parent.showLoading({ text: '正在分析路线......' });
    $.get(urltemp, function (json) {
        parent.hideLoading();

        var data = eval(json);
        if (data.status == 0) {
            showMsg("请求失败(" + data.infocode + ")：" + data.info);
            return;
        }
       
        var resultHtml;
        if (selectedType == "nav-type-bus") {//bus 
            if (data.route.transits.length == 0) {
                showMsg("未查询到公交路线！");
                return;
            }
            var paths0 = data.route.transits[0];//公交换乘方案，第1条

            endMpt.taxi_cost = Number(data.route.taxi_cost).toFixed(0) + "元";              //打车费用 
            endMpt.strategy = parent.formatLength(data.route.distance);                     //起点和终点的步行距离

            endMpt.cost = Number(paths0.cost).toFixed(0) + "元";                        //此换乘方案价格
            endMpt.duration = parent.formatTime(paths0.duration);                       //预期时间 
            endMpt.walking_distance = parent.formatLength(paths0.walking_distance);   //此方案总步行距离 

            resultHtml = parent.workLXGH.addRouteBus(startMpt, endMpt, paths0.segments);
        }
        else {
            if (data.route.paths.length == 0) {
                showMsg("未查询到驾车路线！");
                return;
            }
            var paths0 = data.route.paths[0];

            endMpt.strategy = paths0.strategy;     //导航策略
            endMpt.taxi_cost = Number(data.route.taxi_cost).toFixed(0) + "元";      //打车费用 
            endMpt.tolls = Number(paths0.tolls).toFixed(0) + "元";      //道路收费

            endMpt.duration = parent.formatTime(paths0.duration);     //预计行驶时间 
            endMpt.distance = parent.formatLength(paths0.distance);  //行驶距离
            endMpt.toll_distance = parent.formatLength(paths0.toll_distance);   //收费道路长度

            resultHtml = parent.workLXGH.addRouteCar(startMpt, endMpt, paths0.steps);
        }

        //显示结果
        $("#route-history-list").hide();
        $("#smartTip").hide(); 
        $("#resultlist").show();
        $("#resultul").html(resultHtml); 
        $("#footer_clear").show();

        toIndex();
    });

}



//随机数组中随机取1个元素
function getRandomArrayOne(arr) {
    var n = Math.floor(Math.random() * arr.length + 1) - 1;
    return arr[n];
}



function showMsg(msg) {
    //底部提示
    parent.layer.open({ content: msg, skin: 'footer' });
}