﻿//H5 操作手机端原生相关功能
//创建：汪浩（qq :346819890） 2016-12-8

// H5 plus事件处理
function plusReady() {
    showHelloPage();
	updateSerivces();
}
if(window.plus) {
	plusReady();
} else {
	document.addEventListener("plusready", plusReady, false);
}

//打开手机地图导航
function openSysMap(dst_arr, dst_name, src_arr) {

    // 设置目标位置坐标点和其实位置坐标点
    var dst = new plus.maps.Point(dst_arr[1], dst_arr[0]); // 导航目的地坐标
    var src = new plus.maps.Point(src_arr[1], src_arr[0]); // 导航起始地描述

    // 调用系统地图显示 
    plus.maps.openSysMap(dst, dst_name, src);
}



// 截屏及分享
var lastShareData = {
    isShare: true,
    id: 'qq',
    scene:'',
};


function shareWeiXin() {//分享到微信的“我的好友”
    captureWebview(true, 'weixin', 'WXSceneSession');
} 
function shareWeiXinPYQ() {//分享到微信的“朋友圈”
    captureWebview(true, 'weixin', 'WXSceneTimeline');
}
function shareQQ() {//分享到QQ
    captureWebview(true, 'qq');
}
function shareWeibo() {//分享到新浪微博
    captureWebview(true, 'sinaweibo');
}

function captureWebview(share, id, scene) {
    lastShareData.isShare = share;
    lastShareData.id = id;
    lastShareData.scene = scene;

	var wc = plus.webview.getLaunchWebview();
	var bitmap = new plus.nativeObj.Bitmap("map");
	// 将webview内容绘制到Bitmap对象中
	wc.draw(bitmap, function() {
		console.log('绘制图片成功');
		bitmap.save( "_doc/map.jpg"
			,{}
			,function(i){
				bitmap.clear();
				console.log('保存图片成功：' + JSON.stringify(i));
				if (lastShareData.isShare)
				    shareImg(i.target);
				else
				    showMsg("保存图片成功！ ");
			}
			,function(e){
				console.log('保存图片失败：'+JSON.stringify(e));
			});
	}, function(e) {
		console.log('绘制图片失败：' + JSON.stringify(e));
	});

}

//分享
var shares;
var shareMsg;

function updateSerivces() {
	plus.share.getServices(function(s) {
		shares = {};
		for(var i in s) {
			var t = s[i];
			shares[t.id] = t;
		}
		console.log("获取分享服务列表成功");
	}, function(e) {
		console.log("获取分享服务列表失败：" + e.message);
	});
}

function shareImg(pictures) {
	shareMsg = {
		content: "余杭天地图APP分享",
		pictures:[pictures],
		extra: {
		    scene: lastShareData.scene //微信分享场景，仅微信分享平台有效: "WXSceneSession"分享到微信的“我的好友”； "WXSceneTimeline"分享到微信的“朋友圈”中； "WXSceneFavorite"分享到微信的“我的收藏”中。
		}
	};
	shareAction(lastShareData.id); //用于表示分享服务标识，如“sinaweibo”表示新浪微博、“tencentweibo”表示腾讯微博、“weixin”表示微信、“qq”表示腾讯QQ。
}

function shareAction(id) {
	var s = null;
	if(!id || !(s = shares[id])) {
		console.log("无效的分享服务！");
		return;
	}
	if(s.authenticated) { //已授权 
		shareMessage(s);
	} else { //未授权 
		s.authorize(function() {
			shareMessage(s);
		}, function(e) {
			console.log("认证授权失败：" + e.code + " - " + e.message);
		});
	}
}

function shareMessage(s) {
	s.send(shareMsg, function() {
		showMsg("分享到\"" + s.description + "\"成功！ ");
	}, function(e) {
		console.log("分享到\"" + s.description + "\"失败: " + e.code + " - " + e.message);
	});
}