﻿//index.html页面js：初始化，UI操作，非地图业务等
//创建：汪浩（qq :346819890） 2016-11-18

 

$(document).ready(function () {

    //加载配置信息
    $.getJSON("config/system.json", function (data) {
        //初始化地图
        initMapForConfig(data.map);  
    });

    //POI查询
    $("#txt_query_poi").click(function (event) {
        showExPage('pages/querypoi.html');
    });
    $("#btn_query_poi").click(function (event) {
        var text = $.trim($("#txt_query_poi").val());
        showExPage('pages/querypoi.html?key=' + text);
    });

    //图层控制
    $("#content_layer_manager").on("click", function () {
        $(this).next().show(500);
    });
    $(".bg").on("click", function () {
        $(this).parent().hide(500);
    });

    //路线 
    $("#foot_lx").click(function (event) {
        removeNativeClass();
        $(this).addClass("native");

        showExPage('pages/route.html');
    });
    //规划
    $("#foot_gh").click(function (event) {
        removeNativeClass();
        //$(this).addClass("native");

        //workGHTJ.activate();
        showExPage('pages/queryDz.html');
    });
    //联动
    $("#foot_ld").click(function (event) {
        removeNativeClass();

     	drawWidget.Instance().activate(); 
    });
    //更多
    $("#foot_more").click(function (event) {
        removeNativeClass();
        //$(this).addClass("native");

        $("#content_more").fadeIn(300);
    });
     
});

function removeNativeClass() {
    $("#foot_lx").removeClass("native");
    $("#foot_gh").removeClass("native");
    $("#foot_ld").removeClass("native");
    $("#foot_more").removeClass("native");
}

//隐藏更多面板
function hideMoreView() {
    $("#content_more").fadeOut(300);
}

//弹出新页面通用控制方法
function showExPage(url) { 
    $("#expages").fadeIn(300);

    if (url != null && url!='') {
        var lastsrc = $("#ifrm").attr("src");
        if (lastsrc != url || url=='pages/swipe.html')
            $("#ifrm").attr("src", url);
    }
}

function hideExPage() {
    $("#expages").fadeOut(300);
}


function hideUIView() {
    $("#content_header").hide();
    $("#content_footer").hide();
    $("#content_layer_manager").hide(); 
}


function showUIView() {
    $("#content_header").show();
    $("#content_footer").show();
    $("#content_layer_manager").show(); 
}

function clearALL() {
    removeNativeClass();

    workLXGH.clear();
    workZBCX.clear(); 
    workGHTJ.clearResult();
    workGXSB.updateVisible(false);
    workLD.hide();

}

function showMsg(msg) {
    //底部提示
    layer.open({ content: msg, skin: 'footer' });
}


var hello_cookie = "helloAPP";
function showHelloPage() {
    var lastcookie = getCookie(hello_cookie);
    
    if (!lastcookie)
        showExPage('pages/hello.html');

};
function hideHelloPage() {
    hideExPage();
    addCookie(hello_cookie, true);
}

