﻿
//============================房产================================
var workFangChan = { 
    layer: null,
    bindData: function () {
        //poi arcgcis服务 
        var poiurl = gisdata.config.yhserver.fangchan_arcgis;
        var query = L.esri.query({
            url: poiurl
        });
        query.where(" 1=1 ");
        query.orderBy('序号', 'ASC');

        query.bounds(function (error, latLngBounds, response) {
            var layer = L.featureGroup([]);

            var features = response.features;
            $.each(features, function (index, item) { 
                var mpt = [item.geometry.y, item.geometry.x];
                var marker = L.marker(mpt, {
                    icon: L.icon({
                        iconUrl: 'resources/img/marker/fangchan.png',
                        iconSize: [24, 24],
                        iconAnchor: [12, 12],
                        popupAnchor: [0, -12],
                        tooltipAnchor: [0, -12]
                    })
                });

                //
                var inhtml = ""; 
                for (var col in item.attributes) {
                    var showval = $.trim(item.attributes[col]);
                    if (showval == null || showval == '' || showval == '0' || showval.length == 0) continue;
                    if (col =='序号') continue;
                     
                    if (!isChinese(col)) continue;
  
                    inhtml += col + ":" + showval + "<br/>";
                }
                marker.bindPopup(inhtml);

                layer.addLayer(marker);
            });



            if (workFangChan.visible)
                map.addLayer(layer);
            workFangChan.layer = layer;
        });
    },
    visible: false,
    changeVisible: function (visible) {
        this.visible = visible;
        if (this.layer == null)
            this.bindData();
        else {
            if (visible)
                map.addLayer(this.layer);
            else
                map.removeLayer(this.layer);
        }
    }
}
