﻿
//============================更新上报================================
var workGXSB = {
    layerWork: null,
    lastSelMark: null,
    initLayer: function () {
        this.layerWork = L.photo.cluster({ spiderfyDistanceMultiplier: 1.2 }).addTo(map);
        this.layerWork.on('click', function (evt) {
            var attr = evt.layer.photo;
            workGXSB.lastSelMark = attr;
            showExPage('pages/gxsb_show.html?id=' + attr.ID);

            var ifrm = $("#ifrm")[0].contentWindow;
            if (ifrm && ifrm.showSelectGXSB)
                ifrm.showSelectGXSB(attr);
        });
    },
    clear: function () {
        if (this.layerWork == null)
            return;
        this.layerWork.clear();
        this.data = {};
    },
    updateVisible: function (visible) {
        if (this.layerWork == null)
            return;

        if (visible) {
            map.addLayer(this.layerWork);
        }
        else {
            map.removeLayer(this.layerWork);
        }
    },
    isloadOK: false,
    data: {},
    getById: function (id) {
        return this.data[id];
    },
    loadData: function (arrdata) {
        var $this = this;
        $this.isloadOK = true;
        if ($this.layerWork == null)
            $this.initLayer();

        var newarr = [];
        $.each(arrdata, function (index, item) {
            if (item.LONGITUDE == 0 || item.LATITUDE == 0)
                return;

            //地图mark使用
            item.lng = item.LONGITUDE;
            item.lat = item.LATITUDE;

            if (item.img_def == "../resources/img/work/timg.jpg")
                item.thumbnail = "resources/img/work/timg.jpg";
            else
                item.thumbnail = item.img_def;

            $this.data[item.ID] = item;
            newarr.push(item);
        });

        $this.layerWork.add(newarr);
        fitBounds($this.layerWork.getBounds());
    },
    centerAt: function (id) {
        hideExPage();
        var item = this.getById(id);

        map.panTo([item.lat, item.lng]);
    }


}