﻿
//============================热力图================================
var workHeat = {
    gradient: { 0.4: "blue", 0.6: "cyan", 0.7: "lime", 0.8: "yellow", 1: "red" },
    layer: null,
    bindData: function () {
        //poi arcgcis服务 
        var poiurl = gisdata.config.yhserver.poi_arcgis;
        var query = L.esri.query({
            url: poiurl
        });
        query.where("NAME like '%'");
        query.orderBy('YHDB.DBO.poi.LEN', 'ASC');

        query.bounds(function (error, latLngBounds, response) {
            var features = response.features;
            var arrmpts = [];
            $.each(features, function (index, item) {
                var value = 1;  //item.attributes.FSCALE_OLD / item.attributes.FSCALE_NEW;
                arrmpts.push([item.geometry.y, item.geometry.x, value]);
            });
            var heat = L.heatLayer(arrmpts, {
                radius: 25,
                gradient: workHeat.gradient
            });

            if (workHeat.visible)
                map.addLayer(heat);
            workHeat.layer = heat;
        });
    },
    visible: false,
    changeVisible: function (visible) {
        this.visible = visible;
        if (this.layer == null)
            this.bindData();
        else {
            if (visible)
                map.addLayer(this.layer);
            else
                map.removeLayer(this.layer);
        }
    }
}
