﻿
//============================联动================================
var workLD = {
    layerWork: null,
    lastSelMark: null,
    initLayer: function () {
        this.layerWork = L.photo.cluster({ spiderfyDistanceMultiplier: 1.2 });
        this.layerWork.on('click', function (evt) {
            var attr = evt.layer.photo;
            workLD.lastSelMark = attr;
            showExPage('pages/ld.html');

            var ifrm = $("#ifrm")[0].contentWindow;
            if (ifrm && ifrm.showSelectLd)
                ifrm.showSelectLd(attr);
        });
    },
    visible: false,
    showhide: function () {
        if (this.layerWork == null)
            this.initLayer();

        this.visible = !this.visible;
        if (this.visible) {
            map.addLayer(this.layerWork);
            if (!this.isloadOK)
                this.loadData();
            else
                fitBounds(this.layerWork.getBounds());
        }
        else {
            map.removeLayer(this.layerWork);
        }
    },
    hide: function () {
        if (this.layerWork == null)
            return; 
        this.visible = false; 
        map.removeLayer(this.layerWork); 
    },
    isloadOK: false,
    loadData: function () {
        var query = L.esri.query({
            url: gisdata.config.yhserver.ld
        });
        query.where(" 1=1 ");
        query.orderBy('XH', 'ASC');

        query.bounds(function (error, latLngBounds, response) {
            workLD.isloadOK = true;

            var arrdata = [];
            var features = response.features;
            $.each(features, function (index, item) {
                var attributes = item.attributes;
                attributes.lng = item.geometry.x;
                attributes.lat = item.geometry.y;
                attributes.img = [];

                var strzp = attributes.ZPMC;
                if (strzp == null || strzp == '')
                    strzp = "resources/img/work/timg.jpg"
                else {
                    var arr = strzp.split(',');
                    for (var j = 0; j < arr.length; j++) {
                        arr[j] = gisdata.config.yhserver.ld_img + arr[j];
                    }
                    attributes.img = arr;
                    strzp = arr[arr.length - 1];
                }

                attributes.thumbnail = strzp;

                arrdata.push(attributes);
            });
            workLD.layerWork.add(arrdata);
            fitBounds(workLD.layerWork.getBounds());
        });
    }


}