L.drawLocal = {
    draw: {
        toolbar: {
            // #TODO: this should be reorganized where actions are nested in actions
            // ex: actions.undo  or actions.cancel
            actions: {
                title: '取消绘制',
                text: '取消'
            },
            finish: {
                title: '完成绘制',
                text: '完成'
            },
            undo: {
                title: '删除最后一个绘制的点',
                text: '删除最后的点'
            },
            buttons: {
                polyline: '绘制折线',
                polygon: '绘制多边形',
                rectangle: '绘制矩形',
                circle: '绘制圆',
                marker: '标点'
            }
        },
        handlers: {
            circle: {
                tooltip: {
                    start: '单击并拖动到绘制圆'
                },
                radius: '半径'
            },
            marker: {
                tooltip: {
                    start: '点击地图标记点'
                }
            },
            polygon: {
                tooltip: {
                    start: '点击开始绘制形状',
                    cont: '单击继续绘制形状',
                    end: '单击继续绘制，双击完成绘制'
                }
            },
            polyline: {
                error: '<strong>错误:</strong> 线边缘不能交叉!',
                tooltip: {
                    start: '点击开始画线',
                    cont: '单击继续画线',
                    end: '单击继续画线,双击完成绘制'
                }
            },
            rectangle: {
                tooltip: {
                    start: '单击并拖动绘制矩形'
                }
            },
            simpleshape: {
                tooltip: {
                    end: '释放鼠标完成绘图'
                }
            }
        }
    },
    edit: {
        toolbar: {
            actions: {
                save: {
                    title: '保存修改.',
                    text: '保存'
                },
                cancel: {
                    title: '取消编辑，丢弃所有的修改',
                    text: '取消'
                }
            },
            buttons: {
                edit: '编辑要素',
                editDisabled: '没有需要编辑的要素',
                remove: '删除要素',
                removeDisabled: '没有需要删除的要素'
            }
        },
        handlers: {
            edit: {
                tooltip: {
                    text: '拖动句柄，或标记来编辑功能',
                    subtext: '单击“取消”以撤消更改'
                }
            },
            remove: {
                tooltip: {
                    text: '点击目标进行删除'
                }
            }
        }
    }
};